﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BaileyElectionApp
{
    class ElectionUI
    {
        const int NUMOFCANDIDATES = 5;
        private Election elect = new Election();

        public ElectionUI()
        {
        }

        public void MainMethod()
        {
            for (int i = 0; i < NUMOFCANDIDATES; i++)
            {
                string candidateName = PromptForString(i);
                elect.SetCandidateName(candidateName, i);

                int amountOfVotes = PromptForInt(candidateName);
                elect.SetCandidateVotes(amountOfVotes, i);
            }

            Console.Clear();
            displayResults(NUMOFCANDIDATES);
        }

        private static String PromptForString(int value)
        {
            Console.Write("\nPlease enter candidate {0}'s name: \t", value + 1);
            return Console.ReadLine();
        }

        private static int PromptForInt(string name)
        {
            int votes;

            Console.Write("Please enter {0}'s votes: \t\t", name);
            int.TryParse(Console.ReadLine(), out votes);

            return votes;
        }

        public void displayResults(int NUMOFCANDIDATES)
        {
            Console.WriteLine("*********************************************************");
            Console.WriteLine("*\tName \t\tVotes \t\tPercent\t\t*");
            Console.WriteLine("*********************************************************");

            for (int i = 0; i < NUMOFCANDIDATES; i++)
            {
                int candidateVotes = elect.GetCandidateVotes(i);
                double total = candidateVotes / (double)elect.TotalVotes();

                Console.WriteLine("*\t{0} \t\t{1} \t\t{2:P1}\t\t*", elect.GetCandidateName(i), candidateVotes, total);
            }

            int winner = elect.FindWinner();

            Console.WriteLine("*********************************************************\n");
            Console.WriteLine("\n\nThe winner is... {0} ! Congratulations !!", elect.GetCandidateName(winner));

        }
    }
}
